function fit_cielconstant, image, imCIEL

;A-Masque les etoiles et autres sources tres positives iterativement

imagemasquee = image
for iter=0, 2 do begin
	cielmed = median(image)
	cielecartmed = ecart_median(image)
	indmasque = where((image-cielmed)/cielecartmed gt 3.0,nindmasque)
	if nindmasque ge 1 then imagemasquee[indmasque] = !VALUES.F_NAN
endfor

;B-Essaye differentes constantes en minimalisant l'ecart median dans l'image
constantemax = median(imagemasquee) ;si l'image est presque saturee, constantemax~30000

;Commence par reperer a peu pres le niveau de la constante, 6 essais grossiers
constante = (findgen(6))*constantemax/6.0
ecartmed = fltarr(6)
for i=0,5 do begin
	;Soustrait une constante a l'image
	imagetmp = (imagemasquee - constante[i])
	;Soustrait ensuite le ciel selon la mediane du ciel qui reste dans l'image
	imagetmp = imagetmp - (imCIEL * median(imagetmp) / median(imCIEL))
	;Mesure l'ecart type du fond de ciel resultant afin de minimiser l'ecart type
	ecartmed[i] = ecart_median(imagetmp)
endfor
;Trouve a quel des 6 essais on obtient le meilleur fit
indexmin = where(ecartmed eq min(ecartmed))

;Conserve les 3 points les plus proches du minimum
indexopti = [indexmin-1, indexmin, indexmin+1]
indexopti = indexopti[where(indexopti ge 0 and indexopti lt 6)]
constante = constante[indexopti]

;Subdivise en 14 niveaux plus fins et recommence le minimisation de l'ecart type
constante = findgen(14)/14.0*1.5*(constante[n_elements(constante)-1] - constante[0]) + constante[0]
ecartmed = fltarr(14)
for i=0,13 do begin
	;Soustrait une constante a l'image
	imagetmp = (imagemasquee - constante[i])
	;Soustrait ensuite le ciel selon la mediane du ciel qui reste dans l'image
	imagetmp = imagetmp - (imCIEL * median(imagetmp) / median(imCIEL))
	;Mesure l'ecart type du fond de ciel resultant afin de minimiser l'ecart type
	ecartmed[i] = ecart_median(imagetmp)
endfor

;Trouve a quel des 14 essais on obtient le meilleur fit
indexmin = where(ecartmed eq min(ecartmed), nindexmin)
if nindexmin ge 1 then begin
	print, 'Le meilleur fit est avec une constante de...', constante[indexmin[0]]
	imagefinale = (image - constante[indexmin[0]])
	imagefinale = imagefinale - (imCIEL * median(imagefinale) / median(imCIEL))
endif else begin
	print, 'Attention! pas de minimum a l''ecart type de le soustraction du ciel.'
	imagefinale = image - (imCIEL * median(imagefinale) / median(imCIEL))
endelse

return, imagefinale

end
