pro imcorrel, nomIMAGES, deltax, deltay

print,'Le nom de chaque image reduite:'
for i=0,n_elements(nomIMAGES)-1 do begin
	print, nomIMAGES[i]
endfor

deltax_courant = fltarr(n_elements(nomIMAGES))
deltay_courant = fltarr(n_elements(nomIMAGES))

imref = readfits(nomIMAGES[0])
for im=0, n_elements(nomIMAGES)-1 do begin
	;Prend le profil de chaque image selon x et y
	;fonctionne bien si les mauvais pixels sont a NAN mais
	;total retourne de la scrap si les mauvais pixels ne
	;sont pas flagges. Il faut aussi que le ciel soit a zero.
	image = readfits(nomIMAGES[im])
	ligne1 = total(imref,1,/nan)
	ligne2 = total(image,1,/nan)
	colonne1 = total(imref,2,/nan)
	colonne2 = total(image,2,/nan)

	;Correlation croisee de deux lignes
	for iter=1,2 do begin
		if iter eq 1 then begin
			deltamin = -500.0
			deltamax = 500.0
			deltapas = 1.0
		endif
		if iter eq 2 then begin
			deltamin = centre - 20.0
			deltamax = centre + 20.0
			deltapas = 0.1
		endif

		npas = floor((deltamax-deltamin)/deltapas)+1
		degre = fltarr(npas)
		delta = findgen(npas)*deltapas+deltamin
		for i=0,npas-1 do begin
			degre[i] = C_CORRELATE(ligne1, ligne2, delta[i],/DOUBLE)
		endfor
		plot, delta, degre

		if iter eq 1 then begin
			ind = where(max(degre) eq degre)
			centre = median(delta[ind])
		endif
		if iter eq 2 then begin
			yfit = GAUSSFIT(delta, degre, A, nterms=6)
			oplot, delta, yfit
			centre = A[1]
		endif
		print, centre
	endfor
	deltay_courant[im] = centre


	;Correlation croisee de deux colonnes
	for iter=1,2 do begin
		if iter eq 1 then begin
			deltamin = -500.0
			deltamax = 500.0
			deltapas = 1.0
		endif
		if iter eq 2 then begin
			deltamin = centre - 15.0
			deltamax = centre + 15.0
			deltapas = 0.1
		endif

		npas = floor((deltamax-deltamin)/deltapas)+1
		degre = fltarr(npas)
		delta = findgen(npas)*deltapas+deltamin
		for i=0,npas-1 do begin
			degre[i] = C_CORRELATE(colonne1, colonne2, delta[i],/DOUBLE)
		endfor
		plot, delta, degre

		if iter eq 1 then begin
			ind = where(max(degre) eq degre)
			centre = median(delta[ind])
		endif
		if iter eq 2 then begin
			yfit = GAUSSFIT(delta, degre, A, nterms=6)
			oplot, delta, yfit
			centre = A[1]
		endif
		print, centre
	endfor
	deltax_courant[im] = centre
endfor

;Organise le vecteur des deltas
deltax = fltarr(n_elements(nomIMAGES))
deltay = fltarr(n_elements(nomIMAGES))
for i=0,n_elements(nomIMAGES)-1 do begin
	deltax[i] = -(deltax_courant[i] - deltax_courant[0])
	deltay[i] = -(deltay_courant[i] - deltay_courant[0])
endfor

end