pro simon_automatique, nomOBJbrut, $
	ciel=ciel, skip_makelog=skip_makelog, skip_makecalib=skip_makecalib

;Si vous voulez utiliser une image de ciel differente de celle appelee automatiquement,
; alors attribuez le nom de ce ciel au keyword 'ciel'.
; ex: simon_automatique, listeobjet, ciel='ciel_a_moi.fits'

goto, etape2a
;goto, etape2

;Cette procedure a pour but de faire la reduction entierement automatique
;des images de SIMON dans le mode imagerie si on ne lui fournit que le strict
;minimum, c'est-a-dire le nom des images brutes a reduire.
;Certaines suppositions sont quand meme faites:
;1-Que des flats on et off sont faits la meme nuit
;2-Que des darks pour tous les temps de pose sont fait la meme nuit
;3-Que les objets portent a peu pres le bon titre 'dark', 'flaton' ou 'flatoff'

	;Les images de flats ne sont pas fournies, utilisons les flats
	;d'archive que l'on peut trouver sur cyga (132.204.61.23 ou
	;132.204.60.43) dans /home/simon/imageref/
	;Les images de darks ne sont pas fournies, utilisons les darks
	;d'archive que l'on peut trouver sur cyga (132.204.61.23 ou
	;132.204.60.43) dans /home/simon/imageref/
	;L'image des mauvais pixels n'est pas fournie, utilisons l'image
	;d'archive que l'on peut trouver sur cygameg (132.204.61.23 ou
	;cyga 132.204.60.43) dans /home/simon/imageref/

;goto, etape1c
;goto, etape2b

if keyword_set(skip_makelog) then goto, etape1b
;Trouve d'abord quel est le type d'image dont il est question: objet, dark, flaton, flatoff?
print, 'Determine le type d''image (objet, dark, flat)...' & print
openw, unite, 'listetype.txt', /get_lun
for image=0, n_elements(nomOBJbrut)-1 do begin
	imOBJtmp = readfits(nomOBJbrut[image], entete, /silent)
	filtre = simon_detectefiltre(entete)
	obstype = simon_detectetype(entete)
	texp = sxpar(entete, 'TINT')
	ncoa = sxpar(entete, 'NCOA')
	nlec = sxpar(entete, 'NLEC')
	print, format='(A40, A10, A10, F, I, I)', nomOBJbrut[image], obstype, filtre, texp, ncoa, nlec
	printf, unite, format='(A40, A10, A10, F, I, I)',$
		nomOBJbrut[image], obstype, filtre, texp, ncoa, nlec
endfor
close, unite
free_lun, unite


etape1b:

;************************** FAIT LES DARKS ********************************

if keyword_set(skip_makecalib) then goto, etape2a

;Regroupe les darks en temps d'exposition egaux
readcol, 'listetype.txt', format='(A40,A15,A15,F,I,I)', nomOBJbrut, obstype, filtre, texp, ncoa, nlec

index = where(strcmp(obstype, 'dark') eq 1, nindex)
if nindex ge 1 then begin
	texpdark = texp[index]
	nlecdark = nlec[index]
	nomOBJbrutdark = nomOBJbrut[index]

	listetexp = 0.0
	for i=0, n_elements(nomOBJbrutdark)-1 do begin
		index2 = where(listetexp eq texpdark[i], nindex2)
		if nindex2 lt 1 then begin
			;Ce temps d'exposition n'est pas encore compte
			listetexp = [listetexp, texpdark[i]]
		endif
	endfor
	listetexp = listetexp[1:n_elements(listetexp)-1]

	;Lance la reduction des differents darks pour chaque temps d'exposition
	print & print, 'Lance la reduction automatique des darks...' & print
	for i=0, n_elements(listetexp)-1 do begin
		;Determine la liste des images brutes de dark
		index =  where( (strcmp(obstype, 'dark') eq 1) and (texp eq listetexp[i]), nindex)
		nomDARKbrut = nomOBJbrut[index]
		print, nomDARKbrut

		;Determine le nom du dark reduit final
		if strcmp(!version.os_family, 'Windows') ne 1 then begin
			toto = strsplit(nomOBJbrut[0],'/',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			texp_string = string(listetexp[i],format='(F10.2)')
			nomDARKfinal = strcompress('dark_'+date+'_'+texp_string+'sec'+'.fits',/remove_all)
			print, nomDARKfinal
		endif else begin
			toto = strsplit(nomOBJbrut[0],'\',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			texp_string = string(listetexp[i],format='(F10.2)')
			nomDARKfinal = strcompress('dark_'+date+'_'+texp_string+'sec'+'.fits',/remove_all)
			print, nomDARKfinal
		endelse

		;Lance le programme de reduction des darks
		simon_dark, nomDARKbrut, nomDARKfinal
	endfor
endif

etape1c:

;************************* FAIT LES FLATS ********************************

;Regroupe les flats par filtre et par temps d'exposition egaux
readcol, 'listetype.txt', format='(A40,A10,A10,F,I,I)', nomOBJbrut, obstype, filtre, texp, ncoa, nlec

indexon = where( strcmp(obstype, 'flaton') eq 1, nindexon)
if nindexon ge 1 then begin
	nomOBJbrutflaton = nomOBJbrut[indexon]
	filtreflaton = filtre[indexon]

	;Determine les differents filtres utilises pour les flats ON
	listefiltre = ''
	for i=0, n_elements(filtreflaton)-1 do begin
		index = where(strcmp(listefiltre,filtreflaton[i]) eq 1,nindex)
		if nindex lt 1 then begin
			;Le filtre n'est pas encore compte
			listefiltre = [listefiltre, filtreflaton[i]]
		endif
	endfor
	listefiltre = listefiltre[1:n_elements(listefiltre)-1]

	;Lance la reduction des differents flats pour chaque filtre
	;Loop pour chaque filtre
	print & print, 'Lance la reduction automatique des flats...' & print
	for i=0, n_elements(listefiltre)-1 do begin
		;Determine la liste des images brutes des flats ON
		index =  where( (strcmp(obstype, 'flaton') eq 1) and $
				(strcmp(filtre, listefiltre[i]) eq 1), nindex)
		nomFLATallume = nomOBJbrut[index]
		print, nomFLATallume

		;Determine la liste des images brutes des flats OFF
		index =  where( (strcmp(obstype, 'flatoff') eq 1) and $
				(strcmp(filtre, listefiltre[i]) eq 1), nindex)
		nomFLATeteint = nomOBJbrut[index]
		print, nomFLATeteint

		;Determine le nom du flat reduit
		if strcmp(!version.os_family, 'Windows') ne 1 then begin
			toto = strsplit(nomOBJbrut[0],'/',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			nomFLATfinal = strcompress('flat_'+date+'_'+string(listefiltre[i])+'.fits',/remove_all)
			print, nomFLATfinal
		endif else begin
			toto = strsplit(nomOBJbrut[0],'\',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			nomFLATfinal = strcompress('flat_'+date+'_'+string(listefiltre[i])+'.fits',/remove_all)
			print, nomFLATfinal
		endelse

		;Lance le programme de reduction des flats
		simon_flat, nomFLATallume, nomFLATeteint, nomFLATfinal
	endfor
endif


;goto, fin



etape2a:

;Cree ensuite un fichier de log decrivant chaque image a reduire
openw, unite, 'listeauto.txt', /get_lun

;Amorce le boucle sur chaque image a reduire
for image=0, n_elements(nomOBJbrut)-1 do begin
	imOBJtmp = readfits(nomOBJbrut[image], entete,/silent)
	filtre = simon_detectefiltre(entete)
	obstype = simon_detectetype(entete)
	if strcmp(filtre, '-1') ne 1 then begin
		;Cherche le temps de pose, ncoa, nlec, pat
		texp = sxpar(entete, 'TINT')
		ncoa = sxpar(entete, 'NCOA')
		nlec = sxpar(entete, 'NLEC')
		pat = sxpar(entete, 'MIRPAT') ;tim10.lod
		if nlec ne 1 then $
			print, 'Attention! Votre image a plus d''un nlec et est reduite avec un dark de un nlec.'
		if strcmp(pat,'tim10.lod') ne 1 then $
			print, 'Attention! Le patron de lecture de votre image n''est pas standard a 10 microsecondes.'

		;Cherche le nom du dark
		if strcmp(!version.os_family, 'Windows') ne 1 then begin
			toto = strsplit(nomOBJbrut[0],'/',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			texp_string = string(texp,format='(F10.2)')
			nomDARKfinal = strcompress('dark_'+date+'_'+texp_string+'sec'+'.fits',/remove_all)
		endif else begin
			toto = strsplit(nomOBJbrut[0],'\',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			texp_string = string(texp,format='(F10.2)')
			nomDARKfinal = strcompress('dark_'+date+'_'+texp_string+'sec'+'.fits',/remove_all)
		endelse

		if file_test(nomDARKfinal) eq 1 then begin
			nomDARK = nomDARKfinal
		endif else begin
			nomDARK = 'rien'
		endelse

		;Cherche le nom du flat field
		if strcmp(!version.os_family, 'Windows') ne 1 then begin
			toto = strsplit(nomOBJbrut[0],'/',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
		endif else begin
			toto = strsplit(nomOBJbrut[0],'\',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
		endelse
		case 1 of
			strcmp(filtre,'I',/fold_case) eq 1: begin
				;Determine le nom du flat reduit
				nomFLATfinal = strcompress('flat_'+date+'_I.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_I_030613.fits'
				endelse
			end
			strcmp(filtre,'J',/fold_case) eq 1: begin
				nomFLATfinal = strcompress('flat_'+date+'_J.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_J_030613.fits'
				endelse
			end
			strcmp(filtre,'H',/fold_case) eq 1: begin
				;Determine le nom du flat reduit
				nomFLATfinal = strcompress('flat_'+date+'_H.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_H_030613.fits'
				endelse
			end
			strcmp(filtre,'Ks',/fold_case) eq 1: begin
				nomFLATfinal = strcompress('flat_'+date+'_Ks.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_K_030613.fits'
				endelse
			end
			strcmp(filtre,'H2',/fold_case) eq 1: begin
				;Determine le nom du flat reduit
				nomFLATfinal = strcompress('flat_'+date+'_H2.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_H2_030613.fits'
				endelse
			end
			strcmp(filtre,'FeII',/fold_case) eq 1: begin
				nomFLATfinal = strcompress('flat_'+date+'_FeII.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_FeII_030613.fits'
				endelse
			end
			strcmp(filtre,'BrGamma',/fold_case) eq 1: begin
				;Determine le nom du flat reduit
				nomFLATfinal = strcompress('flat_'+date+'_BrGamma.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_BrGamma_030613.fits'
				endelse
			end
			strcmp(filtre,'PaBeta',/fold_case) eq 1: begin
				nomFLATfinal = strcompress('flat_'+date+'_PaBeta.fits',/remove_all)
				if file_test(nomFLATfinal) eq 1 then begin
					nomFLAT = nomFLATfinal
				endif else begin
					nomFLAT = 'flat_PaBeta_030613.fits'
				endelse
			end
			strcmp(filtre,'blank',/fold_case) eq 1: begin
				nomFLAT = 'rien'
			end
			else: begin
				print, 'Attention! Il n''y a pas de flatfield disponible pour ce filtre. Utilise flat en J'
				nomFLAT = 'flat_J_030613.fits'
			end
		endcase

		;Cherche le nom du badpix
		nomBADPIX = 'badpix030212.fits'

		;Determine le nom de l'image reduite, et de l'image reduite avec le ciel
		if stregex(nomOBJbrut[image],'fits.gz',/fold_case) ne -1 then begin
			;c'est un fichier .fits.gz
			if strcmp(!version.os_family, 'Windows') ne 1 then begin
				toto = strsplit(nomOBJbrut[image], '/',/extract)
				toto2 = strcompress('red'+toto[n_elements(toto)-1],/remove_all)
				toto3 = strsplit(toto2, '.gz',/extract,/regex)
				nomOBJredu = toto3[0]
				toto2 = strcompress('tmp'+toto[n_elements(toto)-1],/remove_all)
				toto3 = strsplit(toto2, '.gz',/extract,/regex)
				nomOBJredutmp = toto3[0]
			endif else begin
				toto = strsplit(nomOBJbrut[image], '\',/extract)
				toto2 = strcompress('red'+toto[n_elements(toto)-1],/remove_all)
				toto3 = strsplit(toto2, '.gz',/extract,/regex)
				nomOBJredu = toto3[0]
				toto2 = strcompress('tmp'+toto[n_elements(toto)-1],/remove_all)
				toto3 = strsplit(toto2, '.gz',/extract,/regex)
				nomOBJredutmp = toto3[0]
			endelse
		endif
		if stregex(nomOBJbrut[image],'fits',/fold_case) ne -1 then begin
			;c'est un fichier .fits
			if strcmp(!version.os_family, 'Windows') ne 1 then begin
				toto = strsplit(nomOBJbrut[image], '/',/extract)
				nomOBJredu = strcompress('red'+toto[n_elements(toto)-1],/remove_all)
				nomOBJredutmp = strcompress('tmp'+toto[n_elements(toto)-1],/remove_all)
			endif else begin
				toto = strsplit(nomOBJbrut[image], '\',/extract)
				nomOBJredu = strcompress('red'+toto[n_elements(toto)-1],/remove_all)
				nomOBJredutmp = strcompress('tmp'+toto[n_elements(toto)-1],/remove_all)
			endelse
		endif

		;Ecrit ca dans le fichier de log
		print, format='(A40, A10, F, A10)', nomOBJbrut[image],  filtre, texp, pat
		printf, unite, format='(A40, A10, A15, F10.2, I, I, A40, A40, A40, A40, A40, A40)',$
				nomOBJbrut[image], obstype, filtre, texp, ncoa, nlec, pat, $
				nomDARK, nomFLAT, nomBADPIX, nomOBJredu, nomOBJredutmp

	endif
endfor

close, unite
free_lun, unite











etape2b:

;Lit le fichier log et procede a la reduction des images

readcol, 'listeauto.txt', format='(A40, A10, A15, F10.2, I, I, A40, A40, A40, A40, A40, A40)',$
		nomOBJbrut, obstype, filtre, texp, ncoa, nlec, pat, $
		nomDARK, nomFLAT, nomBADPIX, nomOBJredu, nomOBJredutmp

;Determine les differents filtres utilises
listefiltre = ''
for i=0, n_elements(filtre)-1 do begin
	if strcmp(obstype[i],'objet') eq 1 then begin
		index = where(strcmp(listefiltre,filtre[i]) eq 1,nindex)
		if nindex lt 1 then begin
			;Le filtre n'est pas encore compte
			listefiltre = [listefiltre, filtre[i]]
		endif
	endif
endfor
listefiltre = listefiltre[1:n_elements(listefiltre)-1]

index = where(strcmp(listefiltre, 'blank') ne 1, nindex)
listefiltre = listefiltre[index]

print, 'Filtres utilises: ', listefiltre


;;Si l'utilisateur passe le nom d'images de ciel au lieu des ciels automatiques, construit
;;un vecteur des filtres correspondants
;if keyword_set(ciel) then begin
;	;L'utilisateur specifie des ciels a lui plutot que ceux determines automatiquement
;	for i=0, n_elements(ciel)-1 do begin
;		imciel = readfits(ciel[i],entete,/silent)
;		filtreciel = sxpar(entete,'filtre')
;		index = where(strcmp(filtre, 'filtreciel') eq 1, nindex)
;		if nindex ge 1 then begin
;			;Il y a des images avec le ciel a changer
;			nomCIEL[index] = ciel[i]
;		endif
;	endfor
;endif


;Fait la reduction, filtre par filtre, image par image
;dark_oao = readfits('dark_oao_030613.fits',/silent)
;dark_pente = readfits('dark_pente_030613.fits',/silent)
dark_pente = readfits('dark_CFHTpente.fits',/silent)
dark_oao = readfits('dark_cfhtoao.fits',/silent)
for fil=0, n_elements(listefiltre)-1 do begin

	index = where(strcmp(filtre, listefiltre[fil]) eq 1 and $
			strcmp(obstype, 'objet') eq 1, nindex)
	print, 'FILTRE ',listefiltre[fil]
	print, 'Nombre d''images dans ce filtre: ', nindex

	;Construit le ciel
	if keyword_set(ciel) then begin
		;L'utilisateur specifie son ciel a lui plutot que celui determine automatiquement
		nomCIEL = ciel[0]
	endif else begin
		for i=0, nindex-1 do begin
			if strcmp(nomDARK[index[i]], 'rien') eq 1 then begin
				nomDARK[index[i]] = 'darktmp.fits'
				imDARK = dark_oao + dark_pente*texp[index[i]]
				writefits, nomDARK[index[i]], imDARK
			endif
			simon_objet, nomOBJbrut[index[i]], nomOBJredutmp[index[i]], nomFLAT[index[i]], $
				nomDARK[index[i]], nomBADPIX=nomBADPIX[index[i]], /garde_ciel
		endfor
		if strcmp(!version.os_family, 'Windows') ne 1 then begin
			toto = strsplit(nomOBJbrut[0],'/',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			nomCIEL = strcompress('ciel_'+date+'_'+listefiltre[fil]+'.fits',/remove_all)
		endif else begin
			toto = strsplit(nomOBJbrut[0],'\',/extract)
			toto2 = strsplit(toto[n_elements(toto)-1], '_',/extract)
			date = toto2[0]
			nomCIEL = strcompress('ciel_'+date+'_'+listefiltre[fil]+'.fits',/remove_all)
		endelse
		simon_ciel, nomOBJredutmp[index], nomCIEL
	endelse

	;Reduit les images
	for i=0, nindex-1 do begin
		if strcmp(nomDARK[index[i]], 'rien') eq 1 then begin
			nomDARK[index[i]] = 'darktmp.fits'
			imDARK = dark_oao + dark_pente*texp[index[i]]
			writefits, nomDARK[index[i]], imDARK
		endif
		simon_objet, nomOBJbrut[index[i]], nomOBJredu[index[i]], nomFLAT[index[i]], $
			nomDARK[index[i]], nomBADPIX=nomBADPIX[index[i]], nomCIEL=nomCIEL, $
			/soustrait_ligne_mediane, /soustrait_colonne_mediane
		;Efface les images temporaires creees
		;spawn, strcompress('\rm -rf '+nomOBJredutmp[index[i]])
	endfor

endfor

;spawn, '\rm -rf darktmp.fits'

fin:

end
