pro simon_badpix, nomFLATS, nomBADPIX, nomOAO=nomOAO, nomPENTE=nomPENTE


if n_elements(nomFLATS) gt 1 then begin
	print,'Genere une image des mauvais pixels de SIMON a partir de flats de differentes intensites.'
endif else begin
	print,'Genere une image des mauvais pixels de SIMON a partir d''un bon flat.'
	nomPENTE = nomFLATS
	goto, partie2
endelse




;Initialise les dimensions
dimx = 1024
dimy = 1024
dimz = n_elements(nomFLATS)
imFLATS = fltarr(dimx,dimy,dimz)
exptime = fltarr(dimz)
cielval = fltarr(dimz)

;Lecture des images brutes et trimming
print, 'Lecture des images pour fabriquer l''image de badpixels...'
if keyword_set(trim_sec) then begin
for i=0, dimz-1 do begin
	imtmp = readfits(nomFLATS[i], entete)
	imFLATS[*,*,i] = imtmp[trim_sec[0]-1:trim_sec[1]-1,trim_sec[2]-1:trim_sec[3]-1]
	exptime[i] = sxpar(entete, 'TEFF') * sxpar(entete, 'NCOA')
	cielval[i] = median(imFLATS[*,*,i])
	;cielval[i] = exptime[i]
endfor
endif else begin
	for i=0, dimz-1 do begin
		imFLATS[*,*,i] = readfits(nomFLATS[i], entete)
		exptime[i] = sxpar(entete, 'TEFF') * sxpar(entete, 'NCOA')
		cielval[i] = median(imFLATS[*,*,i])
		;cielval[i] = exptime[i]
	endfor
endelse


;ladfit pour chaque pixel
print, 'Regression lineaire pour trouver la pente et l''oao de chaque pixel...'
valeur = fltarr(dimz)
imOAO = fltarr(dimx, dimy)
imPENTE = fltarr(dimx,dimy)
for i=0, dimx-1 do begin
for j=0, dimy-1 do begin
	for k=0, dimz-1 do begin
		valeur[k] = imFLATS[i,j,k]
	endfor
	fitparam = ladfit(cielval, valeur)
	imOAO[i,j] = fitparam[0]
	imPENTE[i,j] = fitparam[1]
endfor
	plot, cielval, valeur, psym=3
	print, strcompress(string(i)+'/'+string(dimx-1),/remove_all)
endfor


;Sauve l'image de la pente et de l'ordonnee a l'origine
writefits, nomOAO, imOAO
writefits, nomPENTE, imPENTE








partie2:
;A PARTIR D'ICI, LE FLAT EST FAIT ET ON GENERE LA CARTE DES MAUVAIS PIXELS.
print, 'Scanne le flat pour mettre les mauvais pixels a NAN...'

flat = readfits(nomPENTE,/silent)

;Initialise les dimensions de l'image des mauvais pixels et
;determine les limites des deux amplis.
dimx = 1024
dimy = 1024
gauchemin = 0
gauchemax = 1023
imBADPIX = fltarr(dimx,dimy)
imBADPIX = imBADPIX * 0.0 + 1.0

;Debute les loops
;Ajuster les trois parametres suivants si vous trouvez que le nombre
;de mauvais pixels est trop grand ou trop petit, en particulier le
;sigmacut qui pourrait etre un peu plus grand (3.5 ou 4 sigmas).
npixx = 30
npixy = 30
sigmacut = 3.0
ncarrexg = floor((gauchemax-gauchemin)/npixx)
ncarrey = floor(dimy / npixy)

for j=0, ncarrey-2 do begin
	ymin = j*npixy
	ymax = ymin+npixy-1

	for i=0, ncarrexg-2 do begin
		xmin = i*npixx + gauchemin
		xmax = xmin+npixx-1 + gauchemin
		carre = flat[xmin:xmax,ymin:ymax]
		med = median(carre)
		dev = median(abs(carre - med))/.69
		err = abs(carre - med)/dev
		imbadpixtmp = imBADPIX[xmin:xmax,ymin:ymax]
		for x=0, npixx-1 do begin
			for y=0, npixy-1 do begin
				if err[x,y] gt sigmacut then begin
					imbadpixtmp[x,y] = !VALUES.F_NAN
				endif
			endfor
		endfor
		imBADPIX[xmin:xmax,ymin:ymax] = imbadpixtmp
	endfor
	;derniere boucle pour inclure les pixels au bout de l'ampli
	i = ncarrexg-1
		xmin = i*npixx + gauchemin
		xmax = gauchemax
		carre = flat[xmin:xmax,ymin:ymax]
		med = median(carre)
		dev = median(abs(carre - med))/.69
		err = abs(carre - med)/dev
		imbadpixtmp = imBADPIX[xmin:xmax,ymin:ymax]
		for x=0, npixx-1 do begin
			for y=0, npixy-1 do begin
				if err[x,y] gt sigmacut then begin
					imbadpixtmp[x,y] = !VALUES.F_NAN
				endif
			endfor
		endfor
		imBADPIX[xmin:xmax,ymin:ymax] = imbadpixtmp
endfor
;Debut de la derniere boucle en y pour inclure les pixels au bout en
;haut des deux amplis
j = ncarrey-1
	ymin = j*npixy
	ymax = dimy - 1
	;ampli gauche
	for i=0, ncarrexg-2 do begin
		xmin = i*npixx + gauchemin
		xmax = xmin+npixx-1 + gauchemin
		carre = flat[xmin:xmax,ymin:ymax]
		med = median(carre)
		dev = median(abs(carre - med))/.69
		err = abs(carre - med)/dev
		imbadpixtmp = imBADPIX[xmin:xmax,ymin:ymax]
		for x=0, npixx-1 do begin
			for y=0, npixy-1 do begin
				if err[x,y] gt sigmacut then begin
					imbadpixtmp[x,y] = !VALUES.F_NAN
				endif
			endfor
		endfor
		imBADPIX[xmin:xmax,ymin:ymax] = imbadpixtmp
	endfor
	;derniere boucle pour inclure les pixels au bout de l'ampli
	i = ncarrexg-1
		xmin = i*npixx + gauchemin
		xmax = gauchemax
		carre = flat[xmin:xmax,ymin:ymax]
		med = median(carre)
		dev = median(abs(carre - med))/.69
		err = abs(carre - med)/dev
		imbadpixtmp = imBADPIX[xmin:xmax,ymin:ymax]
		for x=0, npixx-1 do begin
			for y=0, npixy-1 do begin
				if err[x,y] gt sigmacut then begin
					imbadpixtmp[x,y] = !VALUES.F_NAN
				endif
			endfor
		endfor
		imBADPIX[xmin:xmax,ymin:ymax] = imbadpixtmp
;fin de la derniere boucle en y


writefits, nomBADPIX, imBADPIX

print, 'Fin de la creation de l''image des mauvais pixels.'

finbadpix:
end
