pro simon_ciel, nomOBJredu, nomCIEL, iteratif=iteratif

;Fabrique un cube des images
imCIEL = fltarr(1024,1024,n_elements(nomOBJredu))
niveauCIEL = fltarr(n_elements(nomOBJredu))
print, strcompress('Fabrique l''image du ciel avec '+string(n_elements(nomOBJredu))+' images.')
;Procede a la lecture, le masquage et la division par la mediane de chaque image reduite
for i = 0, n_elements(nomOBJredu)-1 do begin
	print, '     '+strcompress('*Masque l''image'+string(i+1))
	;Lecture de chaque image reduite mais dont le ciel est toujours present
	imOBJtmp = readfits(nomOBJredu[i],entete,/silent)

	imfiltree = median(imOBJtmp, 21)
	;NAN la ou le filtre median donne des surplus de flux
	moy = median(imfiltree)
	dev = ecart_median(imfiltree)
	indnan3 = where(imfiltree ge moy+3*dev,nind3)
	;NAN la ou il y a des nan dans l'image brute
	indnan1 = where(finite(imOBJtmp) ne 1,nind1)
	;NAN la ou il y a des etoiles faibles
	moy = median(imOBJtmp)
	dev= ecart_median(imOBJtmp)
	indnan2 = where(imOBJtmp ge moy+3*dev,nind2)
	;Met des nan la ou il doit y en avoir
	if nind1 ge 1 then imOBJtmp[indnan1] = !values.f_nan
	if nind2 ge 1 then imOBJtmp[indnan2] = !values.f_nan
	if nind3 ge 1 then imOBJtmp[indnan3] = !values.f_nan

	;Division par la mediane du ciel
	niveauCIEL[i] = median(imOBJtmp)
	imOBJtmp = imOBJtmp / niveauCIEL[i]
	;Met chaque image dans un cube
	imCIEL[*,*,i] = imOBJtmp
endfor

;Mediane le cube
medarr, imCIEL, imCIELfinal
;Trouve le niveau moyen du ciel en adu/sec (n'oublions pas que les images d'input sont normalisees a une seconde)
niveau = mean(niveauCIEL)
;Ecrit l'image du ciel sur disque
writefits, nomCIEL, imCIELfinal
;Relit puis rajoute le niveau du ciel dans l'entete du ciel
imCIELfinal = readfits(nomCIEL, entete, /silent)
SXADDPAR, entete, 'NIVCIEL', niveau
writefits, nomCIEL, imCIELfinal, entete


goto, fin





if keyword_set(iteratif) then begin
;Employer cette maniere si des sources se chevauchent dans vos images et qu'il
;reste des residus negatifs sur vos images reduites finales.

	;Fabrique un cube des images
	imCIEL = fltarr(1024,1024,n_elements(nomOBJredu))
	;Procede a la lecture, le masquage et la division par la mediane de chaque image reduite
	for i = 0, n_elements(nomOBJredu)-1 do begin
		;Lecture de chaque image reduite mais dont le ciel est toujours present
		imOBJtmp = readfits(nomOBJredu[i],/silent)
		;Fabrique une plus grande image pour soustraire la structures de basses frequences
		boite = 200
		imtemplate = fltarr(1024+2*boite,1024+2*boite)+median(imOBJtmp)
		imtemplate[boite:1023+boite,boite:1023+boite] = imOBJtmp
		imOBJtmp = imtemplate
		imsmooth = smooth(effaceNAN(imOBJtmp),boite)
		imagemasquee = imOBJtmp - imsmooth
		;Iterations pour masquer les etoiles et les sources positives
		;imagemasquee = imOBJtmp
		for iter=0, 2 do begin
			cielmed = median(imagemasquee)
			cielecartmed = ecart_median(imagemasquee)
			indmasque = where((imagemasquee-cielmed)/cielecartmed gt 5 ,nindmasque)
			if nindmasque ge 1 then imagemasquee[indmasque] = !VALUES.F_NAN
			tvcm, imagemasquee, z1=cielmed-3*cielecartmed, z2=cielmed+10*cielecartmed
		endfor
		;imOBJtmp = imagemasquee
		imOBJtmp = imagemasquee + imsmooth
		;Remet l'image a la taille de 1024x1024
		imOBJtmp = imOBJtmp[boite:1023+boite,boite:1023+boite]
		;Division par la mediane du ciel
		imOBJtmp = imOBJtmp / median(imOBJtmp)
		;Met chaque image dans un cube
		imCIEL[*,*,i] = imOBJtmp
	endfor

	;Mediane le cube
	medarr, imCIEL, imCIELfinal

	;Nouveau bout
	;Soustrait le ciel de chaque image ayant servi a le construire
	imREDU = fltarr(1024,1024,n_elements(nomOBJredu))
	for i = 0, n_elements(nomOBJredu)-1 do begin
		;Lecture de chaque image reduite mais dont le ciel est toujours present
		imOBJtmp = readfits(nomOBJredu[i],/silent)
		;Fabrique une plus grande image pour soustraire la structures de basses frequences
		boite = 200
		imtemplate = fltarr(1024+2*boite,1024+2*boite)+median(imOBJtmp)
		imtemplate[boite:1023+boite,boite:1023+boite] = imOBJtmp
		imOBJtmp = imtemplate
		imsmooth = smooth(effaceNAN(imOBJtmp),boite)
		imagemasquee = imOBJtmp - imsmooth
		;Iterations pour masquer les etoiles et les sources positives
		;imagemasquee = imOBJtmp
		for iter=0, 2 do begin
			cielmed = median(imagemasquee)
			cielecartmed = ecart_median(imagemasquee)
			indmasque = where((imagemasquee-cielmed)/cielecartmed gt 5 ,nindmasque)
			if nindmasque ge 1 then imagemasquee[indmasque] = !VALUES.F_NAN
			tvcm, imagemasquee, z1=cielmed-3*cielecartmed, z2=cielmed+10*cielecartmed
		endfor
		;imOBJtmp = imagemasquee
		imOBJtmp = imagemasquee + imsmooth
		;Remet l'image a la taille de 1024x1024
		imOBJtmp = imOBJtmp[boite:1023+boite,boite:1023+boite]
		;Division par la mediane du ciel
		imOBJtmp = imOBJtmp / median(imOBJtmp)

		;Soustraction du ciel
		imOBJtmp = imOBJtmp - imCIELfinal
		;Iterations pour la ou il y a des structures negatives
		imagemasquee = imOBJtmp
		for iter=0, 2 do begin
			cielmed = median(imagemasquee)
			cielecartmed = ecart_median(imagemasquee)
			indmasque = where((imagemasquee-cielmed)/cielecartmed lt -3 ,nindmasque)
			if nindmasque ge 1 then imagemasquee[indmasque] = !VALUES.F_NAN
			tvcm, imagemasquee, z1=cielmed-3*cielecartmed, z2=cielmed+10*cielecartmed
		endfor
		imOBJtmp = imagemasquee
		;Remet le ciel comme avant
		imOBJtmp = imOBJtmp + imCIELfinal
		;Met chaque image dans un cube
		imCIEL[*,*,i] = imOBJtmp
	endfor

	;Mediane le cube
	medarr, imCIEL, imCIELfinal
	;Ecrit l'image du ciel sur disque
	writefits, nomCIEL, imCIELfinal
	
endif else begin
	;Fabrique un cube des images
	imCIEL = fltarr(1024,1024,n_elements(nomOBJredu))
	;Procede a la lecture, le masquage et la division par la mediane de chaque image reduite
	for i = 0, n_elements(nomOBJredu)-1 do begin
		;Lecture de chaque image reduite mais dont le ciel est toujours present
		imOBJtmp = readfits(nomOBJredu[i],/silent)
		;Iterations pour masquer les etoiles et les sources positives
		imsmooth = smooth(effaceNAN(imOBJtmp),200)
		imagemasquee = imOBJtmp - imsmooth
		for iter=0, 2 do begin
			cielmed = median(imagemasquee)
			cielecartmed = ecart_median(imagemasquee)
			indmasque = where((imagemasquee-cielmed)/cielecartmed gt 3 ,nindmasque)
			if nindmasque ge 1 then imagemasquee[indmasque] = !VALUES.F_NAN
			tvcm, imagemasquee, z1=cielmed-3*cielecartmed, z2=cielmed+10*cielecartmed
		endfor
		imOBJtmp = imagemasquee + imsmooth
		;Division par la mediane du ciel
		imOBJtmp = imOBJtmp / median(imOBJtmp)
		;Met chaque image dans un cube
		imCIEL[*,*,i] = imOBJtmp
	endfor

	;Mediane le cube
	medarr, imCIEL, imCIELfinal
	;Ecrit l'image du ciel sur disque
	writefits, nomCIEL, imCIELfinal
endelse

fin:
end ;FIN DE LA PROCEDURE SIMON_CIEL
