pro simon_dark_oao_pente, nomDARKS, tint, nomOAO, nomPENTE

print,'Genere les images de l''ordonnee a l''origine et de la pente du dark moyen par seconde.'

;nomDARKS sont les noms des differents darks reduits
;tint sont les temps d'integration pour chaque dark
;nomOAO est le nom de l'image qui contient l'OAO de chaque pixel
;nomPENTE est le nom de l'image qui contient la pente de chaque pixel

;Initialise les dimensions
imDARKS = fltarr(1024,1024,n_elements(nomDARKS))

;Lecture des images brutes
print, 'Lecture des darks reduits...'
for i=0, n_elements(nomDARKS)-1 do begin
	imDARKS[*,*,i] = readfits(nomDARKS[i])
endfor


;ladfit pour chaque pixel
print, 'Regression lineaire pour trouver la pente et l''oao de chaque pixel...'
valeur = fltarr(n_elements(nomDARKS))
imOAO = fltarr(1024,1024)
imPENTE = fltarr(1024,1024)
for i=0,1023 do begin
for j=0,1023 do begin
	for k=0, n_elements(nomDARKS)-1 do begin
		valeur[k] = imDARKS[i,j,k]
	endfor
	fitparam = ladfit(tint, valeur)
	imOAO[i,j] = fitparam[0]
	imPENTE[i,j] = fitparam[1]
	valfit = fitparam[0] + tint*fitparam[1]
endfor
	;plot, tint, valeur, psym=5
	;oplot, tint, valfit
	print, strcompress(string(i)+'/'+string(1023),/remove_all)
endfor


;Sauve l'image de la pente et de l'ordonnee a l'origine
writefits, nomOAO, imOAO
writefits, nomPENTE, imPENTE

end





function faitnoms, prefixe, chiffre, suffixe

	;Decoupe les fichiers en suites liees seulement par '-' ou en simplets.

	virgule = strsplit(chiffre,',',/extract)

	fichiers = 'il est vide'
	for j=0,n_elements(virgule)-1 do begin
		;Trouve les fichiers min et max de chaque suite
		bornes = strsplit(virgule(j),'-',/extract)
		if (n_elements(bornes) eq 2) then begin
			fichier_min = bornes[0]
			fichier_max = bornes[1]
		endif
		if (n_elements(bornes) eq 1) then begin
			fichier_min = bornes[0]
			fichier_max = bornes[0]
		endif

		;Fait le remplissage des fichiers d'une suite
		for k=fix(fichier_min),fix(fichier_max) do begin
			if (fichiers(0) eq 'il est vide') then begin
				fichiers = fichier_min
			endif else begin
				tronque = strtrim(string(k),1)
				while strlen(tronque) lt strlen(fichier_min) do begin
					tronque = strcompress('0' + tronque,/remove_all)
				endwhile
				complet = tronque
				fichiers = [fichiers, complet]
			endelse
		endfor
	endfor

	;Fait LE vecteur des noms complets de toutes les images
	for i=0,n_elements(fichiers)-1 do begin
		if (n_elements(resultat) eq 0) then begin
			bout = strcompress(prefixe + fichiers[0] + suffixe,/remove_all)
			resultat = filtreOS(bout)
		endif else begin
			bout = strcompress(prefixe + fichiers[i] + suffixe,/remove_all)
			resultat = [resultat, filtreOS(bout)]
		endelse
	endfor

;print, resultat

return, resultat

end



function filtreOS, nomfichier

nomfichier=strcompress(nomfichier,/remove_all)

morceaux = strsplit(nomfichier, '/\',/extract)

if strcmp(!version.os_family, 'UNIX',/fold_case) eq 1 then begin
	path_final = strcompress('/' + strjoin( morceaux,'/', /single ))
endif else begin
	if strcmp(!version.os_family, 'Windows',/fold_case) eq 1 then begin
		path_final = strjoin( morceaux,'\', /single )
	endif
endelse

return,path_final

end


