function simon_detectefiltre, entete

raf = sxpar(entete,'RAF')
rag = sxpar(entete,'RAG')
ral = sxpar(entete,'RAL')
ram = sxpar(entete,'RAM')

;Verifie que la RAM est dans une position ouverte pour le mode imagerie
a1 = stregex(ram, 'imagerie',/fold_case)
a2 = stregex(ram, 'ouvert',/fold_case)
if a1 eq -1 and a2 eq -1 then begin
	print, 'Detection du filtre utilise...'
	print, 'La roue a masque n''est pas en mode imagerie!' 
	return, '-1'
endif

;Verifie que la RAG est dans une position ouverte pour le mode imagerie
a1 = stregex(rag, 'ouvert',/fold_case)
if a1 eq -1 then begin
	print, 'Detection du filtre utilise...'
	print, 'La roue a grisms n''est pas en mode imagerie!' 
	return, '-1'
endif

;Verifie l'etat de la RAL: ouvert, Lyot, blank ou filtre
etatral='filtre'
if stregex(ral, 'ouvert',/fold_case) ne -1 then etatral='ouvert'
if stregex(ral, 'omm',/fold_case) ne -1 then etatral='lyot'
if stregex(ral, 'blank',/fold_case) ne -1 then etatral='blank'

;Verifie l'etat de la RAF: ouvert ou filtre
etatraf='filtre'
if stregex(raf, 'ouvert',/fold_case) ne -1 then etatraf='ouvert'

;Etudie les combinaisons de RAF et RAL pour voir que ca se tient
case 1 of
	strcmp(etatral, 'blank'): begin
		;print, 'C''est une image de dark avec le blank!'
		return, 'blank'
	end
	strcmp(etatral, 'ouvert') and strcmp(etatraf, 'ouvert'): begin
		print, 'Aucun filtre, ni dans la RAF ou dans la RAL!'
		return, '-1'
	end
	strcmp(etatral, 'ouvert') and strcmp(etatraf, 'filtre'): begin
		print, 'Position peu convenable car pas de Lyot dans la RAL!'
		return, '-1'
	end
	strcmp(etatral, 'lyot') and strcmp(etatraf, 'ouvert'): begin
		print, 'Position etrange, un Lyot mais pas de filtre!'
		return, '-1'
	end
	strcmp(etatral, 'lyot') and strcmp(etatraf, 'filtre'): begin
		;Position correcte pour un filtre dans la RAF
		if stregex(raf, 'i$',/fold_case) ne -1 then return,'I'
		if stregex(raf, 'j$',/fold_case) ne -1 then return,'J'
		if stregex(raf, 'h$',/fold_case) ne -1 then return,'H'
		if stregex(raf, 'ks$',/fold_case) ne -1 then return,'Ks'
		if stregex(raf, 'h2',/fold_case) ne -1 then return,'H2'
		if stregex(raf, 'fe',/fold_case) ne -1 then return,'FeII'
		if stregex(raf, 'br',/fold_case) ne -1 then return,'BrGamma'
		if stregex(raf, 'pabe',/fold_case) ne -1 or $
			stregex(raf, 'paschenbe',/fold_case) ne -1 or $
			stregex(raf, 'pbe',/fold_case) ne -1 then return,'PaBeta'
		if stregex(raf, 'sp1',/fold_case) ne -1 then return,'SP1'
	end
	strcmp(etatral, 'filtre') and strcmp(etatraf, 'ouvert'): begin
		;Position correcte pour un filtre dans la RAL
		if stregex(ral, 'i$',/fold_case) ne -1 then return,'I'
		if stregex(ral, 'j$',/fold_case) ne -1 then return,'J'
		if stregex(ral, 'h$',/fold_case) ne -1 then return,'H'
		if stregex(ral, 'ks$',/fold_case) ne -1 then return,'Ks'
		if stregex(ral, 'h2',/fold_case) ne -1 then return,'H2'
		if stregex(ral, 'fe',/fold_case) ne -1 then return,'FeII'
		if stregex(ral, 'br',/fold_case) ne -1 then return,'BrGamma'
		if stregex(ral, 'pabe',/fold_case) ne -1 or $
			stregex(ral, 'paschenbe',/fold_case) ne -1 or $
			stregex(ral, 'pbe',/fold_case) ne -1 then return,'PaBeta'
		if stregex(ral, 'sp1',/fold_case) ne -1 then return,'SP1'
	end
endcase


return, '-1'
end
