pro simon_flat, nomFLATallume, nomFLATeteint, nomFLATfinal

;Pour que cette procedure fonctionne bien, il faut avoir suivi la methode
;pour bien prendre les domeflats tel que decrit dans le manuel de SIMON.
;C'est-a-dire, prendre des flats (au moins 5), puis, fermer les lumieres et
;immediatement prendre des darks avec exactement le meme temps de pose et
;le meme nlec (vous pouvez faire des coadds) sans bouger aucune roue de SIMON.
;Si vous n'avez pas pris d'images avec la lampe eteinte, vous pouvez les
;remplacer par une image de DARK (deja reduite avec simon_dark - etape 3 du
;script de reduction en mode imagerie) correspondant au temps de pose de vos flats.
;Dans ce cas, le programme soustrait tous vos flats par ce dark (les resultats
;sont moins bons, surtout en bande K).

debut:

nflaton = n_elements(nomFLATallume)
nflatoff = n_elements(nomFLATeteint)

;Trouve la methode de fabrication des flats
case 1 of

	nflaton eq nflatoff: begin
	;Meilleure methode - lampe ON et lampe OFF
	
		;Regroupe les flats avec lampe eteinte
		imFLATeteint = fltarr(1024,1024,n_elements(nomFLATeteint))
		for i=0,n_elements(nomFLATeteint)-1 do begin
			;Lit chaque image de flat avec lampe eteinte
			imFLATeteint[*,*,i] = readfits(nomFLATeteint[i],entete)
			;Divise par le nombre d'images coaaditionnees et par le nombre de lectures
			imFLATeteint[*,*,i] = imFLATeteint[*,*,i] / (sxpar(entete, 'NCOA') * sxpar(entete, 'NLEC'))
		endfor
		;Fait la mediane de tous les lampes eteintes
		medarr, imFLATeteint, imFLATeteintfinal
	
		;Regroupe les flats avec lampe allumee
		imFLATallume = fltarr(1024,1024,n_elements(nomFLATallume))
		for i=0,n_elements(nomFLATallume)-1 do begin
			;Lit chaque image du flat field
			imFLATallume[*,*,i] = readfits(nomFLATallume[i],entete)
			;Divise par le nombre d'images coaaditionnees et par le nombre de lectures
			imFLATallume[*,*,i] = imFLATallume[*,*,i] / (sxpar(entete, 'NCOA') * sxpar(entete, 'NLEC'))
			;Soustrait le flat eteint approprie
			imFLATallume[*,*,i] = imFLATallume[*,*,i] - imFLATeteintfinal
			;Pour chaque image, divise par la valeur mediane pour obtenir un flat normalise a un
			imFLATallume[*,*,i] = imFLATallume[*,*,i] / median(imFLATallume[*,*,i])
		endfor
		;Fait la mediane de toutes les flats
		medarr, imFLATallume, imFLATallumefinal
	
		writefits, nomFLATfinal, imFLATallumefinal
	end



	nflaton gt 1 and nflatoff eq 1: begin
	;Methode poche - lampe ON, mais juste un dark comme lampe OFF
	
		;Lit le dark deja reduit
		imDARK = readfits(nomFLATeteint)
	
		;Regroupe les flats avec lampe allumee
		imFLATallume = fltarr(1024,1024,n_elements(nomFLATallume))
		for i=0,n_elements(nomFLATallume)-1 do begin
			;Lit chaque image du flat field
			imFLATallume[*,*,i] = readfits(nomFLATallume[i],entete)
			;Divise par le nombre d'images coaaditionnees et par le nombre de lectures
			imFLATallume[*,*,i] = imFLATallume[*,*,i] / (sxpar(entete, 'NCOA') * sxpar(entete, 'NLEC'))
			;Soustrait le dark
			imFLATallume[*,*,i] = imFLATallume[*,*,i] - imDARK
			;Pour chaque image, divise par la valeur mediane pour obtenir un flat normalise a un
			imFLATallume[*,*,i] = imFLATallume[*,*,i] / median(imFLATallume[*,*,i])
		endfor
		;Fait la mediane de toutes les flats
		medarr, imFLATallume, imFLATallumefinal
	
		writefits, nomFLATfinal, imFLATallumefinal

	end



	nflaton gt 1 and nflatoff gt 1 and nflaton ne nflatoff: begin
	;Il y a une erreur! Le nombre de flats allumes et eteints n'est pas le meme!
		print, 'ERREUR! Le nombre de flats allumes et eteints est different!'	
		print, 'On elimine le surplus en partant des premieres images de chaque serie...'
		nflat = min([nflaton,nflatoff])
		nomFLATallume = nomFLATallume[nflaton-nflat:n_elements(nomFLATallume)-1]
		nomFLATeteint = nomFLATeteint[nflatoff-nflat:n_elements(nomFLATeteint)-1]		
		goto, debut
	end


end
		



end
