pro tvcm,im,z1=z1,z2=z2,nb=nb,log=log,zlog=zlog,med=med,nsig=nsig,sigu=sigu,sigd=sigd,ex=ex,zexp=zexp,silent=silent,nfit=nfit,savetiff=savetiff,savejpg=savejpg,nsave=nsave

;Liste des parametres:

;im  : Nom de l'image

;z1  : Niveau minimum a afficher
;z2  : Niveau maximum a afficher

;nb  : Nombre de couleurs accessibles (normalement = !d.table_size, mais parfois, cela ne marche pas tres bien... Il faut donc l'ajuster a la main (genre 255))

;log : Affichage logarythmique
;zlog: Point zero de l'affichage logarythmique >0

;med : Affichage autour de la mediane de l'image
;nsig : Nombre de sigma autour de la mediane a afficher
;sigd : Nombre de sigma en dessous de la mediane a afficher
;sigu : Nombre de sigma par dessus de la mediane a afficher

;ex : Affichage par exposant: valeur de l'exposant
;zexp: Point zero de l'affichage par exposant >0

;silent: Aucun affichage ecrit
;nfit: Pas d'ajustement automatique de grosseur de la matrice a afficher

imf=im
s=size(im)

if not keyword_set(z1) then z1=min(im)
if not keyword_set(z2) then z2=max(im)
if not keyword_set(nb) then nb=!d.table_size
if not keyword_set(nsig) then nsig=0.1
if not keyword_set(zlog) then zlog=1.
if not keyword_set(zexp) then zexp=1.


if keyword_set(nsig) then begin 
 sig=abs(nsig)
 if nsig lt 0 then print,'La valeur de sigma DOIT etre positive, je prends donc la valeur absolue de sigma...'
endif

if keyword_set(zlog) then begin 
 zlog=abs(zlog)
 if zlog lt 0 then print,'La valeur de zlog DOIT etre positive, je prends donc la valeur absolue de zlog...'
 if zlog eq 0 then zlog=0.0001
 if zlog eq 0 then print,'zlog ne doit pas etre egale a zero, je prends dont zlog=0.0001'
endif

if keyword_set(zexp) then begin 
 zexp=abs(zexp)
 if zexp lt 0 then print,'La valeur de zexp DOIT etre positive, je prends donc la valeur absolue de zexp...'
 if zexp eq 0 then zexp=1.
 if zexp eq 0 then print,'zexp ne doit pas etre egale a zero, je prends dont zexp=1'
endif

if (not keyword_set(log)) and (not keyword_set(med)) and (not keyword_set(ex)) then begin
 j=where(imf lt z1,c)
 if c gt 0 then imf[j]=z1
 j=where(imf gt z2,c)
 if c gt 0 then imf[j]=z2
 imf=nb*(imf-z1)/(z2-z1)
 if not keyword_set(silent) then print,'Z1 = ',z1,' Z2 = ',z2
endif

if keyword_set(log) then begin
 if not keyword_set(z1) then a=min(imf)
 if keyword_set(z1) then a=z1
 imf=imf-a+zlog
 imf=alog10(imf)
 if not keyword_set(silent) then print,'Z1 = ',z1,' Z2 = ',z2,' ZLOG= ',zlog
 z1b=z1-a+zlog
 z2b=z2-a+zlog
 if z1b eq 0 then z1b=1E^(-40)
 if z2b eq 0 then z2b=1E^(-40)
 z1b=alog10(z1b)
 z2b=alog10(z2b)
 j=where(imf lt z1b,c)
 if c gt 0 then imf[j]=z1b
 j=where(imf gt z2b,c)
 if c gt 0 then imf[j]=z2b
 imf=nb*(imf-z1b)/(z2b-z1b)
endif

if keyword_set(med) then begin
 med=median(imf)
 std=stddev(imf)
 if not keyword_set(sigd) then z1b=med-nsig*std
 if not keyword_set(sigu) then z2b=med+nsig*std
 if keyword_set(sigd) then z1b=med-sigd*std
 if keyword_set(sigu) then z2b=med+sigu*std
 if not keyword_set(silent) then begin
  print,'Mediane = ',med,' Sigma = ',std
  if not keyword_set(sigu) and not keyword_set(sigd) then print,'Affichage a ',sig,' sigma'
  print,'Z1 = ',z1b,' Z2 = ',z2b
 endif
 j=where(imf lt z1b,c)
 if c gt 0 then imf[j]=z1b
 j=where(imf gt z2b,c)
 if c gt 0 then imf[j]=z2b
 imf=nb*(imf-z1b)/(z2b-z1b)
endif

if keyword_set(ex) then begin
 if not keyword_set(z1) then a=min(imf)
 if keyword_set(z1) then a=z1
 imf=imf-a+zexp
 if not keyword_set(silent) then print,'Z1 = ',z1,' Z2 = ',z2,' ZEXP = ',zexp
 z1b=(z1-a+zexp)
 z2b=(z2-a+zexp)
 j=where(imf lt z1b,c)
 if c gt 0 then imf[j]=z1b
 j=where(imf gt z2b,c)
 if c gt 0 then imf[j]=z2b
 imf=imf^(ex)
 z1b=z1b^(ex)
 z2b=z2b^(ex)
 if (z1b lt z2b) then imf=nb*(imf-z1b)/(z2b-z1b)
 if (z1b gt z2b) then imf=nb*(imf-z2b)/(z1b-z2b)
endif


if keyword_set(nfit) then tv,imf>(-1)<(nb+1)
if not keyword_set(nfit) then begin
 xdim=s(1)
 ydim=s(2)
 wxdim=!d.x_size
 wydim=!d.y_size
 v=fltarr(2)
 v[0]=1.*wxdim/(1.*xdim)
 v[1]=1.*wydim/(1.*ydim)
 vmax=min(v)
 tv,congrid(imf,xdim*vmax,ydim*vmax)>(-1)<(nb+1)
endif

if keyword_set(savetiff) then begin
 if not keyword_set(nsave) then write_tiff,'imtvcm.tiff',(255./nb)*rotate(imf,7)
 if keyword_set(nsave) then write_tiff,nsave,(255./nb)*rotate(imf,7)
endif

if keyword_set(savejpg) then begin
 if not keyword_set(nsave) then write_jpeg,'imtvcm.jpg',(255./nb)*imf,quality=100
 if keyword_set(nsave) then write_jpeg,nsave,(255./nb)*imf,quality=100
endif

end
